SystemOrganization addCategory: #MudTalk!
SystemOrganization addCategory: #'MudTalk-Client'!
SystemOrganization addCategory: #'MudTalk-Tests'!

TestCase subclass: #MudServerTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MudTalk-Tests'!

!MudServerTests methodsFor: 'tests' stamp: 'AlexanderSvyazin 10/16/2012 23:22'!
testStartStop
	|server|
	server := MudServer new.
	server start.
	self should: [server isStarted].
	self shouldnt: [server isStopped].
	server stop.
	self should: [server isStopped].
	self shouldnt: [server isStarted].! !

!MudServerTests methodsFor: 'tests' stamp: 'AlexanderSvyazin 10/12/2012 23:20'!
testState
	|server|
	server := MudServer new.
	self should: [server isStopped].
	self shouldnt: [server isStarted].! !

!FontFamilyMemberAbstract methodsFor: '*MudTalk-Client' stamp: 'AlexanderSvyazin 1/4/2013 20:56'!
isFixedWidth
	^ (self respondsTo: #fileInfo) ifFalse: [ false ]
		ifTrue: [ self fileInfo fixedWidth ]! !

!LogicalFontManager methodsFor: '*MudTalk-Client' stamp: 'AlexanderSvyazin 1/4/2013 21:22'!
fixedWidthFamilies
	^ self allFamilies select: [ :family |
		family members allSatisfy: [ :member | member isFixedWidth ] ].! !

PPToken subclass: #TelnetAoToken
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MudTalk'!

!TelnetAoToken methodsFor: 'events' stamp: 'AlexanderSvyazin 1/4/2013 11:00'!
triggerOn: aEventManager
	aEventManager triggerEvent: #ao! !

PPToken subclass: #TelnetAytToken
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MudTalk'!

!TelnetAytToken methodsFor: 'events' stamp: 'AlexanderSvyazin 1/4/2013 11:01'!
triggerOn: aEventManager
	aEventManager triggerEvent: #ayt! !

PPToken subclass: #TelnetBrkToken
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MudTalk'!

!TelnetBrkToken methodsFor: 'events' stamp: 'AlexanderSvyazin 1/4/2013 11:02'!
triggerOn: aEventManager
	aEventManager triggerEvent: #brk! !

PPToken subclass: #TelnetDmToken
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MudTalk'!

!TelnetDmToken methodsFor: 'events' stamp: 'AlexanderSvyazin 1/4/2013 11:02'!
triggerOn: aEventManager
	aEventManager triggerEvent: #dm! !

PPToken subclass: #TelnetDoToken
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MudTalk'!

!TelnetDoToken methodsFor: 'events' stamp: 'AlexanderSvyazin 1/4/2013 11:56'!
triggerOn: aEventManager
	aEventManager triggerEvent: #do: with: (self value at: 1) asInteger.! !

PPToken subclass: #TelnetDontToken
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MudTalk'!

!TelnetDontToken methodsFor: 'events' stamp: 'AlexanderSvyazin 1/4/2013 11:56'!
triggerOn: aEventManager
	aEventManager triggerEvent: #dont: with: (self value at: 1) asInteger.! !

PPToken subclass: #TelnetEcToken
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MudTalk'!

!TelnetEcToken methodsFor: 'events' stamp: 'AlexanderSvyazin 1/4/2013 11:05'!
triggerOn: aEventManager
	aEventManager triggerEvent: #ec! !

PPToken subclass: #TelnetElToken
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MudTalk'!

!TelnetElToken methodsFor: 'events' stamp: 'AlexanderSvyazin 1/4/2013 11:05'!
triggerOn: aEventManager
	aEventManager triggerEvent: #el! !

PPToken subclass: #TelnetEorToken
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MudTalk'!

!TelnetEorToken methodsFor: 'events' stamp: 'AlexanderSvyazin 1/4/2013 14:46'!
triggerOn: aEventManager
	aEventManager triggerEvent: #eor! !

PPToken subclass: #TelnetGaToken
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MudTalk'!

!TelnetGaToken methodsFor: 'events' stamp: 'AlexanderSvyazin 1/4/2013 11:06'!
triggerOn: aEventManager
	aEventManager triggerEvent: #ga! !

PPToken subclass: #TelnetIpToken
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MudTalk'!

!TelnetIpToken methodsFor: 'events' stamp: 'AlexanderSvyazin 1/4/2013 11:06'!
triggerOn: aEventManager
	aEventManager triggerEvent: #ip! !

PPToken subclass: #TelnetNopToken
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MudTalk'!

!TelnetNopToken methodsFor: 'events' stamp: 'AlexanderSvyazin 1/4/2013 11:07'!
triggerOn: aEventManager
	aEventManager triggerEvent: #nop! !

PPToken subclass: #TelnetSubnegoToken
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MudTalk'!

!TelnetSubnegoToken methodsFor: 'events' stamp: 'AlexanderSvyazin 1/5/2013 16:37'!
triggerOn: aEventManager
	aEventManager triggerEvent: #subnego: with: self value.! !

PPToken subclass: #TelnetTextToken
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MudTalk'!

!TelnetTextToken methodsFor: 'events' stamp: 'AlexanderSvyazin 1/4/2013 12:12'!
triggerOn: aEventManager
	aEventManager triggerEvent: #text: with: self value.! !

PPToken subclass: #TelnetWillToken
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MudTalk'!

!TelnetWillToken methodsFor: 'events' stamp: 'AlexanderSvyazin 1/4/2013 11:56'!
triggerOn: aEventManager
	aEventManager triggerEvent: #will: with: (self value at: 1) asInteger.! !

PPToken subclass: #TelnetWontToken
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MudTalk'!

!TelnetWontToken methodsFor: 'events' stamp: 'AlexanderSvyazin 1/4/2013 11:56'!
triggerOn: aEventManager
	aEventManager triggerEvent: #wont: with: (self value at: 1) asInteger.! !

Object subclass: #MudServer
	instanceVariableNames: 'started'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MudTalk'!

!MudServer methodsFor: 'initialize-release' stamp: 'AlexanderSvyazin 10/12/2012 23:23'!
initialize
	started := false.! !

!MudServer methodsFor: 'state' stamp: 'AlexanderSvyazin 10/12/2012 23:23'!
isStarted
	^ started.! !

!MudServer methodsFor: 'state' stamp: 'AlexanderSvyazin 10/12/2012 23:21'!
isStopped
	^ started not.! !

!MudServer methodsFor: 'start-stop' stamp: 'AlexanderSvyazin 10/12/2012 23:32'!
start
	started := true.! !

!MudServer methodsFor: 'start-stop' stamp: 'AlexanderSvyazin 10/12/2012 23:33'!
stop
	started := false.! !

Object subclass: #MudTalkClient
	instanceVariableNames: 'window inputPane outputPane outputContents doHandlers willHandlers font telnetOptionHandlers server'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MudTalk-Client'!

!MudTalkClient class methodsFor: 'instance creation' stamp: 'AlexanderSvyazin 1/4/2013 22:25'!
openWindowOnHost: aByteString port: aSmallInteger 
	self new openWindowOnHost: aByteString port: aSmallInteger.! !

!MudTalkClient methodsFor: 'connection' stamp: 'AlexanderSvyazin 1/5/2013 15:23'!
connectTo: aHost port: aPort 
	server := MudTalkConnectionToServer new connectTo: aHost port: aPort.! !

!MudTalkClient methodsFor: 'connection' stamp: 'AlexanderSvyazin 1/4/2013 21:48'!
connectionClosedText
	^ '******* CONNECTION CLOSED *******' asText addAttribute: (TextColor color: Color red)! !

!MudTalkClient methodsFor: 'connection' stamp: 'AlexanderSvyazin 1/5/2013 15:23'!
disconnect
	server ifNotNil: [ server terminate ].! !

!MudTalkClient methodsFor: 'connection' stamp: 'AlexanderSvyazin 1/4/2013 21:48'!
disconnected
	self outputText: self connectionClosedText! !

!MudTalkClient methodsFor: 'telnet' stamp: 'AlexanderSvyazin 1/4/2013 22:56'!
do: cmd
	telnetOptionHandlers at: cmd
		ifPresent: [ :handler | handler do: cmd ]
		ifAbsent: [ self unknownDoOption: cmd ]! !

!MudTalkClient methodsFor: 'accessing' stamp: 'AlexanderSvyazin 1/4/2013 21:32'!
fixedWidthFontFamily
	^ (LogicalFontManager current fixedWidthFamilies at: 1) familyName.! !

!MudTalkClient methodsFor: 'accessing' stamp: 'AlexanderSvyazin 1/4/2013 21:29'!
font
	^ font ifNil: [
		font := LogicalFont familyName: (self fixedWidthFontFamily) pointSize: self fontSize]! !

!MudTalkClient methodsFor: 'accessing' stamp: 'AlexanderSvyazin 1/4/2013 21:29'!
fontSize
	^ 10.! !

!MudTalkClient methodsFor: 'telnet' stamp: 'AlexanderSvyazin 1/5/2013 17:58'!
ga
	self traceCr: 'GA received, do nothing'! !

!MudTalkClient methodsFor: 'accessing' stamp: 'AlexanderSvyazin 1/2/2013 17:48'!
getInput
	^nil.! !

!MudTalkClient methodsFor: 'initialization' stamp: 'AlexanderSvyazin 1/4/2013 23:08'!
initialize
	super initialize.
	self installInputPane.
	self installOutputPane.! !

!MudTalkClient methodsFor: 'initialization' stamp: 'AlexanderSvyazin 1/5/2013 16:17'!
initializeTelnetOptionHandlers
	telnetOptionHandlers := Dictionary new.
	telnetOptionHandlers
		at: TelnetOption suppressGoAhead
		put: (MudTalkClientSuppressGoAheadHandler new server: self server);
		at: TelnetOption terminalType
		put: (MudTalkClientTerminalTypeHandler new server: self server)! !

!MudTalkClient methodsFor: 'accessing' stamp: 'AlexanderSvyazin 1/4/2013 21:26'!
inputPane
	^ inputPane ifNil: [
		inputPane := self window newTextEditorFor: self getText: #getInput setText: #sendCommand:.
		inputPane acceptOnCR: true;
			font: self font].! !

!MudTalkClient methodsFor: 'initialization' stamp: 'AlexanderSvyazin 1/5/2013 15:58'!
installInputPane
	self window
		addMorph: self inputPane
		fullFrame: (LayoutFrame fractions: (0@0.75 extent: 1@1)).! !

!MudTalkClient methodsFor: 'initialization' stamp: 'AlexanderSvyazin 1/5/2013 15:58'!
installOutputPane
	self window
		addMorph: self outputPane
		fullFrame: (LayoutFrame fractions: (0@0 extent: 1@0.75)).! !

!MudTalkClient methodsFor: 'initialization' stamp: 'AlexanderSvyazin 1/5/2013 16:37'!
openConnectionOn: aHost port: aPort
	self connectTo: aHost port: aPort.
	server events
		when: #disconnected send: #disconnected to: self;
		when: #text: send: #text: to: self;
		when: #do: send: #do: to: self;
		when: #dont: send: #dont: to: self;
		when: #will: send: #will: to: self;
		when: #wont: send: #wont: to: self;
		when: #subnego: send: #subnego: to: self;
		when: #nop send: #nop to: self;
		when: #dm send: #dm to: self;
		when: #brk send: #brk to: self;
		when: #ip send: #ip to: self;
		when: #ao send: #ao to: self;
		when: #ayt send: #ayt to: self;
		when: #ec send: #ec to: self;
		when: #el send: #el to: self;
		when: #ga send: #ga to: self! !

!MudTalkClient methodsFor: 'initialization' stamp: 'AlexanderSvyazin 1/4/2013 23:08'!
openWindowOnHost: aHost port: aPort
	self openConnectionOn: (NetNameResolver addressForName: aHost) port: aPort.
	self initializeTelnetOptionHandlers.
	self window openInWorld.
	self inputPane takeKeyboardFocus.! !

!MudTalkClient methodsFor: 'accessing' stamp: 'AlexanderSvyazin 1/2/2013 17:39'!
outputContents
	^ outputContents ifNil: [
		outputContents := Text new].! !

!MudTalkClient methodsFor: 'accessing' stamp: 'AlexanderSvyazin 1/4/2013 21:26'!
outputPane
	^ outputPane ifNil: [
		outputPane := self window newTextEditorFor: self getText: #outputContents setText: nil.
		outputPane font: self font].! !

!MudTalkClient methodsFor: 'outputting' stamp: 'AlexanderSvyazin 1/4/2013 17:51'!
outputText: aText
	self outputContents append: aText;
		append: String crlf.
	self changed: #outputContents.
	self outputPane scrollToBottom.! !

!MudTalkClient methodsFor: 'telnet' stamp: 'AlexanderSvyazin 1/5/2013 15:23'!
sendCommand: aText
	server text: aText.
	self changed: #getInput.! !

!MudTalkClient methodsFor: 'accessing' stamp: 'AlexanderSvyazin 1/5/2013 15:25'!
server
	^ server! !

!MudTalkClient methodsFor: 'telnet' stamp: 'AlexanderSvyazin 1/5/2013 18:07'!
subnego: aByteString 
	| option |
	option := (aByteString at: 1) asInteger.
	self subnego: (aByteString copyFrom: 2) option: option! !

!MudTalkClient methodsFor: 'telnet' stamp: 'AlexanderSvyazin 1/5/2013 18:04'!
subnego: aByteString option: option 
	telnetOptionHandlers at: option
		ifPresent: [ :handler | handler subnego: aByteString option: option ]
		ifAbsent: [ self unknownSubnegoOption: option data: aByteString ]! !

!MudTalkClient methodsFor: 'connection' stamp: 'AlexanderSvyazin 1/4/2013 12:13'!
text: line
	self outputText: line asText.! !

!MudTalkClient methodsFor: 'telnet' stamp: 'AlexanderSvyazin 1/4/2013 22:06'!
unknownDoOption: cmd
	self trace: 'unknown DO option: ';
		traceCr: cmd.! !

!MudTalkClient methodsFor: 'telnet' stamp: 'AlexanderSvyazin 1/5/2013 18:06'!
unknownSubnegoOption: option data: aByteString 
	self trace: 'unknown SUBNEGO option: ';
		trace: option;
		trace: ', data size: ';
		traceCr: aByteString size.! !

!MudTalkClient methodsFor: 'telnet' stamp: 'AlexanderSvyazin 1/4/2013 22:06'!
unknownWillOption: cmd
	self trace: 'unknown WILL option: ';
		traceCr: cmd.! !

!MudTalkClient methodsFor: 'telnet' stamp: 'AlexanderSvyazin 1/4/2013 22:57'!
will: cmd
	telnetOptionHandlers at: cmd
		ifPresent: [ :handler | handler will: cmd ]
		ifAbsent: [ self unknownWillOption: cmd ]! !

!MudTalkClient methodsFor: 'accessing' stamp: 'AlexanderSvyazin 1/2/2013 16:34'!
window
	^ window ifNil: [
		window := StandardWindow labelled: 'MUD client']! !

Object subclass: #MudTalkClientSuppressGoAheadHandler
	instanceVariableNames: 'server'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MudTalk-Client'!

!MudTalkClientSuppressGoAheadHandler methodsFor: 'accessing' stamp: 'AlexanderSvyazin 1/5/2013 15:26'!
server
	^ server.! !

!MudTalkClientSuppressGoAheadHandler methodsFor: 'initialization' stamp: 'AlexanderSvyazin 1/5/2013 15:26'!
server: aConnection 
	server := aConnection.! !

!MudTalkClientSuppressGoAheadHandler methodsFor: 'telnet' stamp: 'AlexanderSvyazin 1/5/2013 15:25'!
will: option 
	(option = TelnetOption suppressGoAhead) ifTrue: [ self server do: TelnetOption suppressGoAhead ]! !

Object subclass: #MudTalkClientTerminalTypeHandler
	instanceVariableNames: 'server'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MudTalk-Client'!

!MudTalkClientTerminalTypeHandler methodsFor: 'telnet' stamp: 'AlexanderSvyazin 1/5/2013 16:34'!
bytesForSend
	^ {(TelnetTerminalType send)} asByteArray! !

!MudTalkClientTerminalTypeHandler methodsFor: 'telnet' stamp: 'AlexanderSvyazin 1/5/2013 18:11'!
clientTerminalType
	^ 'MudTalk v0.1'! !

!MudTalkClientTerminalTypeHandler methodsFor: 'telnet' stamp: 'AlexanderSvyazin 1/5/2013 17:18'!
do: option 
	(option = TelnetOption terminalType) ifTrue: [ self server will: TelnetOption terminalType ]! !

!MudTalkClientTerminalTypeHandler methodsFor: 'accessing' stamp: 'AlexanderSvyazin 1/5/2013 16:01'!
server
	^ server! !

!MudTalkClientTerminalTypeHandler methodsFor: 'accessing' stamp: 'AlexanderSvyazin 1/5/2013 16:02'!
server: aConnection
	server := aConnection! !

!MudTalkClientTerminalTypeHandler methodsFor: 'telnet' stamp: 'AlexanderSvyazin 1/5/2013 18:12'!
subnego: aByteString option: option 
	(option = TelnetOption terminalType) ifTrue: [
		self server subnegoStream: [ :stream |
			stream nextPut: TelnetOption terminalType;
				nextPut: TelnetTerminalType is;
				nextPutAll: self clientTerminalType ] ]! !

!MudTalkClientTerminalTypeHandler methodsFor: 'telnet' stamp: 'AlexanderSvyazin 1/5/2013 16:34'!
will: option
	option = TelnetOption terminalType
		ifTrue: [ 
			self server do: TelnetOption terminalType.
			self server subnego: self bytesForSend option: TelnetOption terminalType ]! !

Object subclass: #MudTalkConnectionToServer
	instanceVariableNames: 'stream readingProcess events parser'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MudTalk-Client'!

!MudTalkConnectionToServer methodsFor: 'initialization' stamp: 'AlexanderSvyazin 1/2/2013 20:48'!
connectTo: aHost port: aPort 
	stream := SocketStream openConnectionToHost: aHost port: aPort.
	readingProcess := [self networkReadLoop] forkNamed: 'MUD client network reading process'.! !

!MudTalkConnectionToServer methodsFor: 'network' stamp: 'AlexanderSvyazin 1/5/2013 15:16'!
do: option
	stream nextPut: TelnetParser iacChar;
		nextPut: TelnetParser doChar;
		nextPut: (Character value: option);
		flush.! !

!MudTalkConnectionToServer methodsFor: 'network' stamp: 'AlexanderSvyazin 1/5/2013 15:16'!
dont: option 
	stream nextPut: TelnetParser iacChar;
		nextPut: TelnetParser dontChar;
		nextPut: (Character value: option);
		flush.! !

!MudTalkConnectionToServer methodsFor: 'accessing' stamp: 'AlexanderSvyazin 1/4/2013 14:59'!
events
	^ events ifNil: [ self newEvents ]! !

!MudTalkConnectionToServer methodsFor: 'initialization' stamp: 'AlexanderSvyazin 1/4/2013 15:52'!
initialize
	super initialize.
	parser := TelnetParser parser.! !

!MudTalkConnectionToServer methodsFor: 'private' stamp: 'AlexanderSvyazin 1/4/2013 21:41'!
networkReadLoop
	[ [ self processLineFromServer ] repeat ]
		on: NetworkError
		do: [ self events triggerEvent: #disconnected ]! !

!MudTalkConnectionToServer methodsFor: 'initialization' stamp: 'AlexanderSvyazin 1/4/2013 15:51'!
newEvents
	events := EventManager new.
	^ events! !

!MudTalkConnectionToServer methodsFor: 'private' stamp: 'AlexanderSvyazin 1/4/2013 21:40'!
nextLine
	^ stream nextLine! !

!MudTalkConnectionToServer methodsFor: 'private' stamp: 'AlexanderSvyazin 1/4/2013 14:51'!
processLineFromServer
	| line parsedLine |
	line := self nextLine.
	parsedLine := parser parse: line.
	parsedLine do: [ :token | token triggerOn: self events ]! !

!MudTalkConnectionToServer methodsFor: 'network' stamp: 'AlexanderSvyazin 1/5/2013 17:35'!
subnego: aByteArray
	self subnegoStream: [ :strm | strm nextPutAll: aByteArray ].! !

!MudTalkConnectionToServer methodsFor: 'network' stamp: 'AlexanderSvyazin 1/5/2013 17:37'!
subnego: aByteArray option: anOption
	self subnegoStream: [ :strm | strm nextPut: anOption; nextPutAll: aByteArray ]! !

!MudTalkConnectionToServer methodsFor: 'network' stamp: 'AlexanderSvyazin 1/5/2013 17:35'!
subnegoStream: aBlock
	stream nextPut: TelnetParser iacChar;
		nextPut: TelnetParser sbChar.
	aBlock value: stream.
	stream nextPut: TelnetParser iacChar;
		nextPut: TelnetParser seChar; flush.! !

!MudTalkConnectionToServer methodsFor: 'private' stamp: 'AlexanderSvyazin 1/2/2013 20:49'!
terminateReadingProcess
	readingProcess ifNotNil: [ readingProcess terminate ]! !

!MudTalkConnectionToServer methodsFor: 'network' stamp: 'AlexanderSvyazin 1/5/2013 15:17'!
text: aText
	stream nextPutAll: aText; crlf; flush! !

!MudTalkConnectionToServer methodsFor: 'network' stamp: 'AlexanderSvyazin 1/5/2013 15:17'!
will: option 
	stream nextPut: TelnetParser iacChar;
		nextPut: TelnetParser willChar;
		nextPut: (Character value: option);
		flush.! !

!MudTalkConnectionToServer methodsFor: 'network' stamp: 'AlexanderSvyazin 1/5/2013 15:17'!
wont: option
	stream nextPut: TelnetParser iacChar;
		nextPut: TelnetParser wontChar;
		nextPut: (Character value: option);
		flush.! !

Object subclass: #TelnetOption
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MudTalk'!

!TelnetOption class methodsFor: 'constants' stamp: 'AlexanderSvyazin 1/5/2013 23:03'!
compess2
	^ 86.! !

!TelnetOption class methodsFor: 'constants' stamp: 'AlexanderSvyazin 1/5/2013 23:03'!
compress
	^ 85.! !

!TelnetOption class methodsFor: 'constants' stamp: 'AlexanderSvyazin 1/4/2013 15:29'!
eor
	^ 25.! !

!TelnetOption class methodsFor: 'constants' stamp: 'AlexanderSvyazin 1/5/2013 23:03'!
gmcp
	^ 201.! !

!TelnetOption class methodsFor: 'constants' stamp: 'AlexanderSvyazin 1/5/2013 23:03'!
msp
	^ 90.! !

!TelnetOption class methodsFor: 'constants' stamp: 'AlexanderSvyazin 1/5/2013 23:03'!
mxp
	^ 91.! !

!TelnetOption class methodsFor: 'constants' stamp: 'AlexanderSvyazin 1/5/2013 23:02'!
naws
	^ 31.! !

!TelnetOption class methodsFor: 'constants' stamp: 'AlexanderSvyazin 1/4/2013 13:27'!
suppressGoAhead
	^ 3.! !

!TelnetOption class methodsFor: 'constants' stamp: 'AlexanderSvyazin 1/5/2013 16:08'!
terminalType
	^ 24.! !

Object subclass: #TelnetParser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MudTalk'!

!TelnetParser class methodsFor: 'parsers' stamp: 'AlexanderSvyazin 1/3/2013 23:04'!
anyToken: aTokenClass
	^ #any asParser token: aTokenClass.! !

!TelnetParser class methodsFor: 'parsers' stamp: 'AlexanderSvyazin 1/4/2013 10:55'!
ao
	^ (TelnetParser iac , TelnetParser aoChar asParser) token: TelnetAoToken! !

!TelnetParser class methodsFor: 'constants' stamp: 'AlexanderSvyazin 1/2/2013 23:55'!
aoChar
	^ Character value: 245.! !

!TelnetParser class methodsFor: 'parsers' stamp: 'AlexanderSvyazin 1/4/2013 10:55'!
ayt
 	^ (TelnetParser iac , TelnetParser aytChar asParser) token: TelnetAytToken! !

!TelnetParser class methodsFor: 'constants' stamp: 'AlexanderSvyazin 1/2/2013 23:55'!
aytChar
	^ Character value: 246.! !

!TelnetParser class methodsFor: 'parsers' stamp: 'AlexanderSvyazin 1/4/2013 10:54'!
brk
	^ (TelnetParser iac , TelnetParser brkChar asParser) token: TelnetBrkToken! !

!TelnetParser class methodsFor: 'constants' stamp: 'AlexanderSvyazin 1/2/2013 23:55'!
brkChar
	^ Character value: 243.! !

!TelnetParser class methodsFor: 'parsers' stamp: 'AlexanderSvyazin 1/4/2013 10:54'!
dm
	^ (TelnetParser iac , TelnetParser dmChar asParser) token: TelnetDmToken! !

!TelnetParser class methodsFor: 'constants' stamp: 'AlexanderSvyazin 1/2/2013 23:55'!
dmChar
	^ Character value: 242.! !

!TelnetParser class methodsFor: 'parsers' stamp: 'AlexanderSvyazin 1/3/2013 23:00'!
do
	^ (TelnetParser iac,
		TelnetParser doChar asParser,
		(TelnetParser anyToken: TelnetDoToken)) ==>
			[:parts | parts at: 3].! !

!TelnetParser class methodsFor: 'constants' stamp: 'AlexanderSvyazin 1/2/2013 23:55'!
doChar
	^ Character value: 253.! !

!TelnetParser class methodsFor: 'parsers' stamp: 'AlexanderSvyazin 1/3/2013 23:01'!
dont
	^ (TelnetParser iac,
		TelnetParser dontChar asParser,
		(TelnetParser anyToken: TelnetDontToken)) ==>
			[:parts | parts at: 3].! !

!TelnetParser class methodsFor: 'constants' stamp: 'AlexanderSvyazin 1/2/2013 23:55'!
dontChar
	^ Character value: 254.! !

!TelnetParser class methodsFor: 'parsers' stamp: 'AlexanderSvyazin 1/4/2013 10:54'!
ec
	^ (TelnetParser iac , TelnetParser ecChar asParser) token: TelnetEcToken! !

!TelnetParser class methodsFor: 'constants' stamp: 'AlexanderSvyazin 1/2/2013 23:55'!
ecChar
	^ Character value: 247.! !

!TelnetParser class methodsFor: 'parsers' stamp: 'AlexanderSvyazin 1/4/2013 10:54'!
el
	^ (TelnetParser iac , TelnetParser elChar asParser) token: TelnetElToken! !

!TelnetParser class methodsFor: 'constants' stamp: 'AlexanderSvyazin 1/2/2013 23:55'!
elChar
	^ Character value: 248.! !

!TelnetParser class methodsFor: 'parsers' stamp: 'AlexanderSvyazin 1/4/2013 14:45'!
eor
	^ (TelnetParser iac, TelnetParser eorChar asParser) token: TelnetEorToken.! !

!TelnetParser class methodsFor: 'constants' stamp: 'AlexanderSvyazin 1/4/2013 14:44'!
eorChar
	^ Character value: 239.! !

!TelnetParser class methodsFor: 'constants' stamp: 'AlexanderSvyazin 1/4/2013 15:33'!
eorDelimiter
	^ String with: TelnetParser iacChar with: TelnetParser eorChar.! !

!TelnetParser class methodsFor: 'parsers' stamp: 'AlexanderSvyazin 1/4/2013 10:53'!
ga
	^ (TelnetParser iac , TelnetParser gaChar asParser) token: TelnetGaToken! !

!TelnetParser class methodsFor: 'constants' stamp: 'AlexanderSvyazin 1/2/2013 23:55'!
gaChar
	^ Character value: 249.! !

!TelnetParser class methodsFor: 'parsers' stamp: 'AlexanderSvyazin 1/3/2013 22:52'!
iac
	^ TelnetParser iacChar asParser.! !

!TelnetParser class methodsFor: 'constants' stamp: 'AlexanderSvyazin 1/2/2013 23:55'!
iacChar
	^ Character value: 255.! !

!TelnetParser class methodsFor: 'parsers' stamp: 'AlexanderSvyazin 1/3/2013 23:04'!
iaciac
	^ (TelnetParser iac, TelnetParser iac)
		answer: TelnetParser iacChar.! !

!TelnetParser class methodsFor: 'parsers' stamp: 'AlexanderSvyazin 1/4/2013 10:53'!
ip
	^ (TelnetParser iac , TelnetParser ipChar asParser) token: TelnetIpToken! !

!TelnetParser class methodsFor: 'parsers' stamp: 'AlexanderSvyazin 1/2/2013 23:55'!
ipChar
	^ Character value: 244.! !

!TelnetParser class methodsFor: 'parsers' stamp: 'AlexanderSvyazin 1/4/2013 10:53'!
nop
	^ (TelnetParser iac , TelnetParser nopChar asParser) token: TelnetNopToken! !

!TelnetParser class methodsFor: 'constants' stamp: 'AlexanderSvyazin 1/2/2013 23:55'!
nopChar
	^ Character value: 241.! !

!TelnetParser class methodsFor: 'parsers' stamp: 'AlexanderSvyazin 1/3/2013 23:08'!
normalChar
	^ TelnetParser iaciac / TelnetParser iac negate.! !

!TelnetParser class methodsFor: 'parsers' stamp: 'AlexanderSvyazin 1/3/2013 22:45'!
parser
	^ (TelnetParser special / TelnetParser text) star end.! !

!TelnetParser class methodsFor: 'parsers' stamp: 'AlexanderSvyazin 1/5/2013 17:55'!
sb
	^ (TelnetParser iac, TelnetParser sbChar asParser) answer: #sb! !

!TelnetParser class methodsFor: 'constants' stamp: 'AlexanderSvyazin 1/2/2013 23:55'!
sbChar
	^ Character value: 250.! !

!TelnetParser class methodsFor: 'parsers' stamp: 'AlexanderSvyazin 1/5/2013 17:55'!
se
	^ (TelnetParser iac, TelnetParser seChar asParser) answer: #se! !

!TelnetParser class methodsFor: 'constants' stamp: 'AlexanderSvyazin 1/2/2013 23:55'!
seChar
	^ Character value: 240.! !

!TelnetParser class methodsFor: 'parsers' stamp: 'AlexanderSvyazin 1/5/2013 15:54'!
special
	^ TelnetParser nop /
		TelnetParser dm /
		TelnetParser brk /
		TelnetParser ip /
		TelnetParser ao /
		TelnetParser ayt /
		TelnetParser ec /
		TelnetParser el /
		TelnetParser ga /
		TelnetParser do /
		TelnetParser dont /
		TelnetParser will /
		TelnetParser wont /
		TelnetParser subnego.! !

!TelnetParser class methodsFor: 'parsers' stamp: 'AlexanderSvyazin 1/5/2013 18:00'!
subnego
	^ TelnetParser sb, (TelnetParser normalChar plus token: TelnetSubnegoToken), TelnetParser se ==>
		[ :parts | parts at: 2 ]! !

!TelnetParser class methodsFor: 'parsers' stamp: 'AlexanderSvyazin 1/4/2013 10:46'!
text
	^ TelnetParser normalChar plus ==> [:chars | TelnetTextToken on: (String withAll: chars)].! !

!TelnetParser class methodsFor: 'parsers' stamp: 'AlexanderSvyazin 1/3/2013 23:01'!
will
	^ (TelnetParser iac,
		TelnetParser willChar asParser,
		(TelnetParser anyToken: TelnetWillToken)) ==>
			[:parts | parts at: 3].! !

!TelnetParser class methodsFor: 'constants' stamp: 'AlexanderSvyazin 1/4/2013 11:31'!
willChar
	^ Character value: 251.! !

!TelnetParser class methodsFor: 'parsers' stamp: 'AlexanderSvyazin 1/3/2013 23:01'!
wont
	^ (TelnetParser iac,
		TelnetParser wontChar asParser,
		(TelnetParser anyToken: TelnetWontToken)) ==>
			[:parts | parts at: 3].! !

!TelnetParser class methodsFor: 'constants' stamp: 'AlexanderSvyazin 1/2/2013 23:55'!
wontChar
	^ Character value: 252.! !

Object subclass: #TelnetTerminalType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MudTalk'!

!TelnetTerminalType class methodsFor: 'constants' stamp: 'AlexanderSvyazin 1/5/2013 18:10'!
is
	^ 0.! !

!TelnetTerminalType class methodsFor: 'constants' stamp: 'AlexanderSvyazin 1/5/2013 16:19'!
send
	^ 1.! !
